
#include <stdlib.h>

#include "add.h"

void *add_construct()
{
    ADD_DATA *data = (ADD_DATA *) malloc(sizeof(ADD_DATA));
    data->in1 = (double *) malloc(sizeof(double));
    data->in2 = (double *) malloc(sizeof(double));

    return (void *) data;
}


void add_process(void *data)
{
    ADD_DATA *adddata = (ADD_DATA *) data;
    *adddata->out = *adddata->in1 + *adddata->in2;
}


void add_destroy(void *data)
{
    ADD_DATA *adddata = (ADD_DATA *) data;
    free(adddata->in1);
    free(adddata->in2);
}


void add_set_param(void *data, int index, double value)
{
    return;
}


double *add_get_input(void *data, int index)
{
    ADD_DATA *d = (ADD_DATA *) data;
    switch (index) {
    case ADD_IN1:
        return d->in1;
    case ADD_IN2:
        return d->in2;
    }
    return NULL;
}


void add_set_output(void *data, int index, double *out_buffer)
{
    ADD_DATA *d = (ADD_DATA *) data;
    switch (index) {
    case 0:
        d->out = out_buffer;
        break;
    }
}
