#include <inttypes.h>

typedef enum {
    ADD_IN1 = 0,
    ADD_IN2,
    ADD_NUM_PARAMS
} ADD_PARAMS;

typedef struct {
    double *in1;
    double *in2;
    double *out;
} ADD_DATA;

void *add_construct();

void add_process(void *data);

void add_destroy(void *data);

void add_set_param(void *data, int index, double value);

double *add_get_input(void *data, int index);

void add_set_output(void *data, int index, double *out_buffer);




